#include "sdk.h"
static void put_rc (FRESULT rc)
{
	const char* p =
		"OK\0DISK_ERR\0INT_ERR\0NOT_READY\0NO_FILE\0NO_PATH\0INVALID_NAME\0"
		"DENIED\0EXIST\0INVALID_OBJECT\0WRITE_PROTECTED\0INVALID_DRIVE\0"
		"NOT_ENABLED\0NO_FILE_SYSTEM\0MKFS_ABORTED\0TIMEOUT\0LOCKED\0"
		"NOT_ENOUGH_CORE\0TOO_MANY_OPEN_FILES\0INVALID_PARAMETER\0";
	FRESULT i;

	for (i = 0; i != rc && *p; i++) {
		while(*p++) ;
	}
	debugprintf("rc=%u FR_%s\r\n", (UINT)rc, p);
}

FRESULT print_files (char* path,bool recursive)
{
	FRESULT res;
	FILINFO Finfo;
	DIR dir;
	res = f_opendir(&dir, path);
	if(res != FR_OK)
	{
		put_rc(res);
		return res;
	}

	for (;;) {
		res = f_readdir(&dir, &Finfo);
		if (res != FR_OK || Finfo.fname[0] == 0) break;
		if (Finfo.fattrib & AM_DIR) {
			if(Finfo.fname[0]!='.')
			{
				char dirname[FF_MAX_LFN+1];
					
				if(recursive)
				{
					sprintf(dirname,"%s/%s",path,Finfo.fname);
					print_files(dirname,recursive);
				}
				else 
					debugprintf("[D] %s/%s\r\n",path,Finfo.fname);
				
			}
		} else {
			debugprintf("%s/%s\t%dbyte\r\n", path, Finfo.fname,Finfo.fsize);
		}
	}
	res = f_closedir(&dir);
	if(res != FR_OK)
		put_rc(res);
	return res;
}
