#include "sdk.h"

extern void evmboardinit();

U32 get_adc(U8 ch)
{
    U32 adc_res = 0;
    *R_ADCCTRL2 = 1;
    *R_ADCCTRL  = ch << 5 | F_ADCCTRL_APB128 | F_ADCCTRL_EN | F_ADCCTRL_STC;

    while(!(*R_ADCSTAT & F_ADCSTAT_ADCDR))
        ;
    *R_ADCCTRL = 0;

    adc_res = *R_ADCDATA & 0xfff;

    return adc_res;
}

int adc2temp(int adc)
{
    // adc to  mV
    // 3300mV : 0xfff == mV : adc
    int mV = 3300 * adc / 0xfff;
    if(mV < 100)
        return -40;
    mV -= 100;
    return (-40) + (mV / 10);
}

int main()
{
    evmboardinit();
    uart_config(DEBUG_CHANNEL, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
    debugstring("================================================\r\n");
    debugprintf("adLuna ADC. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
    debugstring("================================================\r\n");

    U32 adc_dat = 0;

    while(1)
    {
        adc_dat = get_adc(0);
        debugprintf("ADC ch 0 = %d, Temperature %d ℃\r\n", adc_dat, adc2temp(adc_dat));
        delayms(500);
    }
    return 0;
}
