
#pragma once

#include "sdk.h"
#include "etc_driver/driver_ssd1351_basic.h"

typedef enum {
    JOYSTICK_TYPE_NONE   = 0,
    JOYSTICK_TYPE_UP     = 1,
    JOYSTICK_TYPE_LEFT   = 2,
    JOYSTICK_TYPE_DOWN   = 3,
    JOYSTICK_TYPE_RIGHT  = 4,
    JOYSTICK_TYPE_CENTER = 5,
} JOYSTICK_TYPE;

JOYSTICK_TYPE get_joystick_type();
#define MAKE_RGB565(r, g, b) ((U16)((((U16)r & 0xf8) << 8) | (((U16)g & 0xfc) << 3) | (((U16)b & 0xf8) >> 3))) ///< make RGB565 from r,g,b
typedef void (*FP)(void);

void fb_draw_rect(int x, int y, int end_x, int end_y, U16 clr);
void fb_draw_pixel(int x, int y, U16 clr);
U16 *fb_get_fremebuffer(int x, int y);
void fb_update_lcd();
void fb_draw_rect(int x, int y, int end_x, int end_y, U16 clr);
uint8_t fb_draw_bmp(uint8_t left, uint8_t top, uint8_t right, uint8_t bottom, uint8_t *bmp);
uint8_t fb_draw_char(uint8_t x, uint8_t y, uint8_t chr, ssd1351_font_t font, uint16_t color);
uint8_t fb_draw_string(uint8_t x, uint8_t y, char *str, uint32_t color, ssd1351_font_t font);
