#include "Demo.h"

// version 0x100
typedef struct {
    unsigned int magic;
    unsigned int version;
    unsigned short w;        // image width
    unsigned short h;        // image height
    unsigned short lpitch;   // allocated memory width 8,16,32,64,128,256,512,1024
    unsigned char bCompress; // 0 : no compress, 1 : RLE
    unsigned char bpp;
} SURF_HEADER;

#define SSD1351_CMD  0 /**< command type */
#define SSD1351_DATA 1 /**< data type */

static void lcd_cmd(U8 cmd)
{
    ssd1351_interface_cmd_data_gpio_write(SSD1351_CMD);
    ssd1351_interface_spi_write(&cmd, 1);
}
static void lcd_data(U8 data)
{
    ssd1351_interface_cmd_data_gpio_write(SSD1351_DATA);
    ssd1351_interface_spi_write(&data, 1);
}

#define SSD1351_CMD_SET_COLUMN_ADDRESS 0x15 /**< set column address command */
#define SSD1351_CMD_SET_ROW_ADDRESS    0x75 /**< set row address command */
#define SSD1351_CMD_WRITE_RAM          0x5C /**< write ram command */

uint8_t ssd1351_basic_draw_suf(uint8_t left, uint8_t top, uint8_t right, uint8_t bottom, uint8_t *suf)
{
    SURF_HEADER *surfheader;
    int i, j;

    surfheader = (SURF_HEADER *)suf;
    if (surfheader->bpp != 16)
        return 1;
    if (surfheader->bCompress)
        return 1;

    lcd_cmd(SSD1351_CMD_SET_COLUMN_ADDRESS);
    lcd_data(left);  // left
    lcd_data(right); // right
    lcd_cmd(SSD1351_CMD_SET_ROW_ADDRESS);
    lcd_data(top);    // top
    lcd_data(bottom); // bottom
    lcd_cmd(SSD1351_CMD_WRITE_RAM);
    U8 *buf = suf + sizeof(SURF_HEADER);
    for (i = 0; i < surfheader->h; i++) {
        for (j = 0; j < surfheader->w; j++) {
            lcd_data(*(buf + 1));
            lcd_data(*buf);
            buf += 2;
        }
    }
    return 0; // sucess
}
