#include "sdk.h"

extern void evmboardinit();

U8 pio_flag = 0;

void GPIO5_ISR()
{
    debugprintf("GPIO 5.2 Falling edge ISR\r\n");
    if(pio_flag)
    {
        *R_GPOHIGH(5) = 1 << 6;
        pio_flag      = 0;
    }
    else
    {
        *R_GPOLOW(5) = 1 << 6;
        pio_flag     = 1;
    }
}

int main()
{
    evmboardinit();
    uart_config(DEBUG_CHANNEL, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
    debugstring("================================================\r\n");
    debugprintf("adLuna GPIO. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
    debugstring("================================================\r\n");

    // P5.2
    *R_GPIDIR(5) = 1 << 2; // P5.2 input

    *R_GPIRQMODE(5) = 0x2;    // Falling interrupt Mode
    *R_GPIRQEN(5)   = 1 << 2; // P5.2 Interrupt enable
    set_interrupt(INTNUM_GPIO5, GPIO5_ISR);
    enable_interrupt(INTNUM_GPIO5, true);

    while(1)
        ;
    return 0;
}
