#include "sdk.h"

extern void evmboardinit();

/*
    debugstring, debugpritnf output channel can be changed using the set_debug_channel.
    ex)
        set_debug_channel(0);
        uart_config(0, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
*/

int main()
{
    evmboardinit();
    uart_config(DEBUG_CHANNEL, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
    debugstring("================================================\r\n");
    debugprintf("adLuna IrDa System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
    debugstring("================================================\r\n");

    uart_config(1, 9600, DATABITS_8, STOPBITS_1, UART_PARNONE);
    uart_set_irda(1, false, false); // Irda mode set, uart_set_irda(int ch, int rx_inversion, int tx_inversion);

    U8 ch;
    while(1)
    {
        if(uart_getch(1, &ch)) // IrDa Rx
        {
            debugprintf("Rx data : 0x%x \r\n", ch);
        }

        if(uart_getch(DEBUG_CHANNEL, &ch))
        {
            uart_putch(1, ch); // IrDa Tx
        }
    }

    while(1)
        ;

    return 0;
}
