
#include "sdk.h"

extern void evmboardinit();
extern void usb_isr(void);

/*  usb_uart function.
 int UsbGetCh(U8* buf);
 void UsbUartPutCh(U8 data);
 void UsbUartPuts(U8 *data);
*/

extern U8 USB_Virtual_DeviceDescriptor[VIRTUAL_COM_PORT_SIZ_DEVICE_DESC];
extern U8 USB_Virtual_ConfigDescriptor[VIRTUAL_COM_PORT_SIZ_CONFIG_DESC];

int main()
{
    evmboardinit();

    uart_config(DEBUG_CHANNEL, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
    debugstring("START\r\n");
    debugstring("================================================\r\n");
    debugprintf("adLuna USB Virtual Com.System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
    debugstring("================================================\r\n");

    usb_clock_init();
    usb_set_description((BYTE *)USB_Virtual_ConfigDescriptor, (BYTE *)USB_Virtual_DeviceDescriptor);
    usb_init(USB_VIRTUAL_COM_MODE);

    InitRingBuf_usb();
    set_interrupt(INTNUM_USB, usb_virtual_com_isr);
    enable_interrupt(INTNUM_USB, TRUE); // usb interrupt enable.  usb_isr function on usb_serial.c

    U8 data;

    while(1)
    {
        if(UsbGetCh(&data))
        {
            UsbUartPutCh(data);
        }
    }

    return 0;
}
