#include "sdk.h"

extern void evmboardinit();
extern void amp_on(bool b);

INCBIN(okwave, "01.wav"); // Add 01.wav file data,

int main()
{
    evmboardinit();
    uart_config(DEBUG_CHANNEL, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
    debugstring("================================================\r\n");
    debugprintf("adLuna WAV Play. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
    debugstring("================================================\r\n");

    sound_init();
    sound_vol(235); // sound vol, max = 255 (default)

    WAVE *pWavOK = sound_loadwavp((U8 *)okwave_data, okwave_end - okwave_data);
    // okwave_data => 01.wav file data
    // okwave_end - okwave_data => 01.wav file size

    amp_on(true);
    while(1)
    {
        sound_play(pWavOK);
        while(sound_isplay(pWavOK))
            ;
        delayms(1000);
    }
    amp_on(false);

    while(1)
        ;
    return 0;
}
