#include "sdk.h"

extern void evmboardinit();
extern void amp_on(bool b);

int main()
{
    evmboardinit();
    uart_config(DEBUG_CHANNEL, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
    debugstring("================================================\r\n");
    debugprintf("adLuna WAV Play. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
    debugstring("================================================\r\n");

   	FATFS fs;
	f_mount(&fs,"0:",1);

    sound_init();
    sound_vol(235); // sound vol, max = 255 (default)

    WAVE *pWav1 = sound_loadwav("owl-hooting-48028.wav");
    WAVE *pWav2 = sound_loadwav("birds_singing-6888.wav");
    WAVE *pWav3 = sound_loadwav("come-with-me-133764.wav");
    pWav1->bLoop=true;
    pWav2->bLoop=true;
    pWav3->bLoop=true;
    sound_play(pWav1);
    sound_play(pWav2);
    sound_play(pWav3);
    amp_on(true);
    while(1)
        ;
    return 0;
}
