#include "sdk.h"

extern void evmboardinit();
extern void printmem(void *buf, DWORD len);

int main()
{
    evmboardinit();
    uart_config(DEBUG_CHANNEL, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
    debugstring("================================================\r\n");
    debugprintf("adLuna Serial Flash. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
    debugstring("================================================\r\n");

    U8 buf[16];
    U8 buf2[16];

    int i = 0;

    for(i = 0; i < 16; i++)
    {
        buf[i]  = i;
        buf2[i] = 0;
    }
    int sector_size = sflash_get_sector_size(0);
    int sector_cnt = sflash_get_size(0)/sector_size;
    int last_sector = sector_cnt-1;
    int target_addr = last_sector*sector_size;
    sflash_erase_sector(0, sector_cnt-1, 1); // 0x7F000
    sflash_write(target_addr, buf, 16);
    sflash_read(target_addr, buf2, 16);

    printmem(buf2, 16);

    while(1)
        ;
    return 0;
}
